// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_util_EqualTo_hpp
#define anna_core_util_EqualTo_hpp

namespace anna {

/**
   Predicado que sirve para aplicar a las busquedas sobre vectores de objetos
   generica.

   \param K Tipo de dato por el que vamos a comparar.
   \param T Clase de la que esta el contenedor que vamos a recorrer.

   La clase T debe tener definido el operador == para el tipo const K.

   \see find_if
*/
template <class K, class T> class EqualTo {
public:
  EqualTo(const K key) : a_key(key) {;}
  EqualTo(const EqualTo<K, T>& other) : a_key(other.a_key) {;}
  bool operator()(T* t) const throw() { return *t == a_key; }
  bool operator()(const T* t) const throw() { return *t == a_key; }

private:
  const K a_key;
};

}

#endif


