// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_codec_basetypes_Float64_hpp
#define anna_diameter_codec_basetypes_Float64_hpp


// Local
#include <anna/diameter/codec/basetypes/AvpData.hpp>

#include <anna/config/defines.hpp>

#include <anna/comm/functions.hpp>

namespace anna {

namespace diameter {

namespace codec {

class Avp;

namespace basetypes {

/**
* Diameter Float64 container
*/
class Float64 : public AvpData {

  F64 a_value;


  // Mandatory for basic diameter type:
  void codeBasic(char* buffer, int &size) throw(anna::RuntimeException);
  void setPrintableString(const char * printableString) throw(anna::RuntimeException);

public:

  virtual ~Float64() {;}

  // Class-specific ////////////////////////////////////////////////////////////////////////////////////
  //
  /**
  * Gets the Float64 value
  *
  * @return Float64 value
  */
  const F64& getValue() const throw() { return a_value; }

  /**
  * Sets the Float64 value
  *
  * @param value Float64 value
  */
  void setValue(const F64& value) throw() { a_value = value; }
  //
  //////////////////////////////////////////////////////////////////////////////////////////////////////


  // gets

  virtual std::string getFormatName() const throw() { return "Float64"; }
  virtual int getSize() const throw() { return 8; }


  // helpers

  std::string asPrintableString() throw(anna::RuntimeException) {
    return anna::functions::asString(a_value);
  }

  std::string asString() throw(anna::RuntimeException) {
    return asPrintableString();
  }


  // sets

  void decode(const char* buffer, const int size) throw(anna::RuntimeException);
};

}
}
}
}

#endif
