// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_ericsson_defines_hpp
#define anna_diameter_helpers_ericsson_defines_hpp


// Local
#include <anna/diameter/helpers/defines.hpp>

// STL
#include <string>


/** Contextualized definitions (avp id) */
#define anna_diameter_helpers_define_avp(avpname,code)  anna_diameter_helpers_define_avp_in_context(avpname,code,ericsson)

/** Contextualized definitions (avp id and values) */
#define anna_diameter_helpers_define_avp_with_values(avpname,code)  anna_diameter_helpers_define_avp_with_values_in_context(avpname,code,ericsson)


namespace anna {

namespace diameter {

namespace helpers {

namespace ericsson {


/**
* Avps
*/
anna_diameter_helpers_define_avp(SCAP_Currency_Code, 544);
anna_diameter_helpers_define_avp(SCAP_Subscription_Id, 553);
anna_diameter_helpers_define_avp(SCAP_Subscription_Id_Data, 554);
anna_diameter_helpers_define_avp_with_values(SCAP_Subscription_Id_Type, 555) {
  enum v_ {
    END_USER_MSISDN = 0,
    END_USER_IMSI = 1,
    END_USER_SIP_URL = 2,
    END_USER_NAI = 3,
    END_USER_PRIVATE = 4
  };
};

anna_diameter_helpers_define_avp(SCAP_Original_Subscription_Id, 559);
anna_diameter_helpers_define_avp_with_values(SCAP_Abnormal_Termination_Reason, 600) {
  enum v_ {
    SERVING_ELEMENT_TERMINATION = 0,
    CONNECTION_TO_USER_BROKEN = 1
  };
};

anna_diameter_helpers_define_avp(SCAP_Granted_Service_Unit, 602);
anna_diameter_helpers_define_avp(SCAP_Cost, 603);
anna_diameter_helpers_define_avp(SCAP_Cost_Information, 604);
anna_diameter_helpers_define_avp(SCAP_Accounting_Correlation_Id, 605);
anna_diameter_helpers_define_avp(SCAP_Requested_Service_Unit, 606);
anna_diameter_helpers_define_avp(SCAP_Service_Parameter_Info, 607);
anna_diameter_helpers_define_avp_with_values(SCAP_Service_Parameter_Type, 608) {
  enum v_ {
    SERVICE_PROVIDER_ID = 0,
    EXTENSION_NUMBER_1 = 1,
    EXTENSION_NUMBER_2 = 2,
    EXTENSION_NUMBER_3 = 3,
    EXTENSION_NUMBER_4 = 4,
    EXTENSION_TEXT = 5,
    GPRS_QUALITY_OF_SERVICE = 6,
    REDIRECTING_PARTY_NUMBER = 7,
    ORIGINATING_LOCATION_INFORMATION = 8,
    TERMINATING_LOCATION_INFORMATION = 9,
    REGION_CHARGING_ORIGIN = 10,
    SUBSCRIPTION_TYPE = 11,
    SMS_DELIVERY_STATUS = 12,
    DAYSOFWEEK_SPECIALDATES_TIMEOFDAY = 13,
    TRAFFIC_CASE = 14,
    DEDICATED_SUB_ACCOUNT = 15,
    NUMBERLIST_CALLINGPARTYNUMBER = 16,
    NUMBERLIST_CALLEDPARTYNUMBER = 17,
    TELESERVICE_CODE = 18,
    N_A = 19
  };
};

anna_diameter_helpers_define_avp(SCAP_Service_Parameter_Value, 609);
anna_diameter_helpers_define_avp(SCAP_Event_Timestamp, 610);
anna_diameter_helpers_define_avp_with_values(SCAP_Unit_Type, 611) {
  enum v_ {
    SERVICE_CREDIT_TIME = 0,
    SERVICE_CREDIT_VOLUME = 1,
    SERVICE_CREDIT_EVENT = 2,
    SERVICE_CREDIT_MONEY = 3
  };
};

anna_diameter_helpers_define_avp(SCAP_Unit_Value, 612);
anna_diameter_helpers_define_avp(SCAP_Used_Service_Unit, 613);
anna_diameter_helpers_define_avp_with_values(SCAP_Requested_Action, 615) {
  enum v_ {
    DIRECT_DEBITING = 0,
    REFUND_ACCOUNT = 1
  };
};

anna_diameter_helpers_define_avp(SCAP_Exponent, 616);
anna_diameter_helpers_define_avp(SCAP_Value_Digits, 617);


/**
* Commands
*/


}
}
}
}


#undef anna_diameter_helpers_define_avp
#undef anna_diameter_helpers_define_avp_with_values

#endif

