// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_http_internal_Tokenizer_hpp
#define anna_http_internal_Tokenizer_hpp

#include <anna/core/util/Recycler.hpp>

#include <anna/http/internal/Token.hpp>

namespace anna {

class DataBlock;

namespace http {

class Tokenizer : public Recycler<Token> {
public:
  void apply(const DataBlock&) throw(RuntimeException);
  void apply(const DataBlock&, const char* separator) throw(RuntimeException);
  void apply(const DataBlock&, const char separator) throw(RuntimeException);

  const Token* operator [](int index) const throw();

  const Token* operator [](const_iterator ii) const throw() {
    return (ii == end()) ? NULL : token(ii);
  }

  static const Token* token(const_iterator ii) throw() { return data(ii); }
  static Token* token(iterator ii) throw() { return data(ii); }

private:
  int createToken(const char* p, const int size) throw() {
    create()->setValue(p, size);
    return size;
  }

  static int find(const char* data, const int size, const char character) throw();
  static int find(const char* data, const int size, const char* searched) throw();
  static bool isSpace(const int c) throw() { return c <= '\t' || c == ' ' || c >= 128; }
};

}
}

#endif
