// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/helpers/tme/codectypes/Unsigned16.hpp>


//------------------------------------------------------------------------------
//---------------------------------------------------- Unsigned16::updateBasic()
//------------------------------------------------------------------------------
void anna::diameter::helpers::tme::codectypes::Unsigned16::updateBasic() throw(anna::RuntimeException) {
  std::string result;
  result += (char)(a_value >> 8);
  result += (char)a_value;
  OctetString::setValue(result);
}


//------------------------------------------------------------------------------
//--------------------------------------------- Unsigned16::setPrintableString()
//------------------------------------------------------------------------------
void anna::diameter::helpers::tme::codectypes::Unsigned16::setPrintableString(const char * printableString) throw(anna::RuntimeException) {
  setValue(atoi(printableString));
}


//------------------------------------------------------------------------------
//--------------------------------------------------------- Unsigned16::decode()
//------------------------------------------------------------------------------
void anna::diameter::helpers::tme::codectypes::Unsigned16::decode(const char* buffer, const int size) throw(anna::RuntimeException) {
  if(!buffer)
    throw anna::RuntimeException("Unsigned16::decode | Null Buffer provided", ANNA_FILE_LOCATION);

  if(size != 2)
    throw anna::RuntimeException("Unsigned16::decode | Buffer length must be 2 bytes", ANNA_FILE_LOCATION);

  a_value = (((U16)buffer[0] << 8)  & 0xFF00) +
            ((U16)buffer[1]         & 0x00FF);
  // Base class decode()
  OctetString::decode(buffer, size);
}
