// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <stdio.h>

#include <anna/config/defines.hpp>

#include <anna/io/BinaryReader.hpp>
#include <anna/io/internal/sccs.hpp>

using namespace std;
using namespace anna;

io::BinaryReader::BinaryReader(const int blockSize) :
  AbstractReader(),
  DataBlock(true),
  a_blockSize(blockSize) {
  sccs::activate();
}

io::BinaryReader::BinaryReader(const char* filename, const int blockSize) :
  AbstractReader(filename),
  DataBlock(true),
  a_blockSize(blockSize) {
  sccs::activate();
}

io::BinaryReader::BinaryReader(const std::string& filename, const int blockSize) :
  AbstractReader(filename),
  DataBlock(true),
  a_blockSize(blockSize) {
  sccs::activate();
}

/* virtual */
io::BinaryReader::~BinaryReader() {
}

const DataBlock* io::BinaryReader::fetch()
throw(RuntimeException) {
  verify();
  allocate(a_blockSize);
  size_t blockSize = fread((char *) getData(), 1, a_blockSize, a_file);

  if(blockSize == 0)
    return NULL;

  setSize(blockSize);
  return this;
}
