// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <iostream>

#include <anna/comm/Communicator.hpp>

#include <anna/test/Menu.hpp>

using namespace std;
using namespace anna;
using namespace anna::comm;

const char* test::Menu::EventData = "test::Menu::Data";

test::Menu::Menu (Communicator* communicator) :
   Handler (communicator, Type::Custom, false),
   a_status (0)
{
   setfd (2);
}

void test::Menu::paint () const
   throw ()   
{
   switch (a_status) {
      case 0:
         cout << "Elija operacion [+|-|*|/|q = quit]: " << flush;  
         break;
      case 1:
         cout << "Indique primer operador: " << flush;
         break;
      case 2:
         cout << "Indique segundo operador: " << flush;
         break;
   }
}

void test::Menu::apply ()
   throw (RuntimeException)
{
   switch (a_status) {
      case 0: 
         cin >> a_data.a_operation;
         switch (a_data.a_operation) {
            case 'q':
            case 'Q':
               a_communicator->requestStop ();
               break;
            case '+':
            case '-':
            case '*':
            case '/':         
               a_status = 1;
               paint ();
               break;
         }
         break;
      case 1:
         cin >> a_data.a_op1;
         a_status = 2;
         paint ();
         break;
      case 2:
         cin >> a_data.a_op2;
         a_communicator->eventUser (EventData, &a_data);
         a_status = 0;
         paint ();
         break;         
   };
}


